Package org.springframework.dao.support

# Interface PersistenceExceptionTranslator

All Known Implementing Classes:
  `ChainedPersistenceExceptionTranslator`

Functional Interface:
  This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

@FunctionalInterface public interface PersistenceExceptionTranslator
Interface implemented by Spring integrations with data access technologies that throw runtime exceptions, such as JPA and Hibernate.

This allows consistent usage of combined exception translation functionality, without forcing a single translator to understand every single possible type of exception.

Since:
  2.0
Author:
  Rod Johnson, Juergen Hoeller

## Method Summary

Modifier and Type
Method
Description
`DataAccessException`
`translateExceptionIfPossible(RuntimeException ex)`
Translate the given runtime exception thrown by a persistence framework to a corresponding exception from Spring's generic `DataAccessException` hierarchy, if possible.

## Method Details

### translateExceptionIfPossible

@Nullable DataAccessException translateExceptionIfPossible(RuntimeException ex)
Translate the given runtime exception thrown by a persistence framework to a corresponding exception from Spring's generic `DataAccessException` hierarchy, if possible.

Do not translate exceptions that are not understood by this translator: for example, if coming from another persistence framework, or resulting from user code or otherwise unrelated to persistence.

Of particular importance is the correct translation to DataIntegrityViolationException, for example on constraint violation. Implementations may use Spring JDBC's sophisticated exception translation to provide further information in the event of SQLException as a root cause.

Parameters:
  `ex` - a RuntimeException to translate
Returns:
  the corresponding DataAccessException (or `null` if the exception could not be translated, as in this case it may result from user code rather than from an actual persistence problem)
See Also:
  - `DataIntegrityViolationException`
  - `org.springframework.jdbc.support.SQLExceptionTranslator`